__doc__ = """TextImage product module."""

__version__ = '0.01'  



from Globals import HTMLFile      
from Globals import MessageDialog 
from Globals import Persistent    

import OFS.Image
import PIL.Image
import cStringIO
import string 
import os

import FTDraw


manage_addTextImageForm = HTMLFile('textImageAdd', globals()) 

def manage_addTextImage(self, 
			id, 
			title='', 
			imWidth=100, imHeight=50, backColor='0xffffff', imFormat='PNG',
			posX=0,	posY=0,	text='Hello', fontFile='', textSize=12,	textColor='0x000000',
			textSplit=None,	strWidth=100, textAlign='LEFT', bitpix='pix', charset='koi8-r', 
			REQUEST=None):
    """Add a object to a folder."""
    
    self = self.this()
    
    self._setObject(id, TextImage(id, title, ''))
    self._getOb(id).set_image_data( imWidth, imHeight, backColor, imFormat,
				    posX, posY, text, fontFile, textSize, textColor,
				    textSplit, strWidth, textAlign, bitpix, charset)
            
    if REQUEST is not None:
	try:	url = self.DestinationURL()
	except:	url = REQUEST['URL1']
	REQUEST.RESPONSE.redirect('%s/manage_main' % url)
    return id

	
class TextImage( OFS.Image.Image ): 

    meta_type = 'TextImage'  

    manage_options = ( 
	{'label': 'Edit',       'action': 'manage_main'},
	{'label': 'Properties', 'action': 'manage_propertiesForm'}, 
	{'label': 'View',       'action': 'manage_viewImage'}, 
	{'label': 'Security',   'action': 'manage_access'},
        ) 

    __ac_permissions__ = (  
	('View management screens', ('manage_tabs','manage_main')),
	('Change permissions',      ('manage_access',)           ),
	('Change Images'     ,     ('manage_edit',)             ),
	('View Images',            ('',)                        ),
	)

    def __init__( self, id, title='', file='' ):
	self.__name__ = id
	self.title = title
	self.precondition = ''

	content_type = ''
	data, size = self._read_data(file)
	content_type = self._get_content_type(file, data, id, content_type)
	self.update_data(data, content_type, size)
	
    manage_viewImage = HTMLFile('textImageView', globals())
    manage_main = HTMLFile('textImageEdit', globals()) 
    
    def manage_edit(	self, title='',
    			imWidth=100, imHeight=50, backColor='0xffffff', imFormat='PNG',
			posX=0,	posY=0,	text='Hello', fontFile='', textSize=12,	textColor='0x000000',
			textSplit=None,	strWidth=100, textAlign='LEFT', bitpix='pix', charset='koi8-r', 
			REQUEST=None): 
	"""doc string """
        self.title = title
        self.set_image_data(imWidth, imHeight, backColor, imFormat,
			    posX, posY, text, fontFile, textSize, textColor,
			    textSplit, strWidth, textAlign, bitpix, charset)

	if REQUEST is not None:
	    return MessageDialog(
		title = 'Edited',
		message = "Properties for %s changed." % self.id,
		action = './manage_main',
		)

    def set_image_data(	self, imWidth=100, imHeight=50, backColor='0xffffff', imFormat='PNG',
			posX=0,	posY=0,	text='Hello', fontFile='', textSize=12,	textColor='0x000000',
			textSplit=None,	strWidth=100, textAlign='LEFT', bitpix='pix', charset='koi8-r', 
			REQUEST=None):
	"""doc string """
        self.imWidth	= imWidth 	= int(imWidth)	
        self.imHeight	= imHeight	= int(imHeight)
        self.posX	= posX		= int(posX) 		
        self.posY	= posY		= int(posY) 		
        self.textSize	= textSize	= int(textSize)
        self.strWidth	= strWidth	= int(strWidth)
        self.backColor	= backColor	
	self.textColor	= textColor	
        self.text	= text = string.replace(text,'\r','')
        self.fontFile	= fontFile 
        self.textSplit	= textSplit
        self.textAlign	= textAlign
        self.bitpix	= bitpix
        self.charset	= charset
	self.imFormat	= imFormat
	
	backColor = backColor[-2:]+backColor[-4:-2]+backColor[-6:-4]	
	textColor = textColor[-2:]+textColor[-4:-2]+textColor[-6:-4]
	backColor = string.atoi(backColor,16)
	textColor = string.atoi(textColor,16)
	fontFile  = os.path.join( INSTANCE_HOME, 'var', 'fonts', fontFile )
		
	im = PIL.Image.new("RGB", (imWidth,imHeight), backColor)

        ft = FTDraw.FTDraw(im)
	ft.fontload(fontFile, textSize, (96,96), bitpix)
	ft.setcharset(charset)
	ft.text( (posX,posY), text, textColor, None, textSplit, strWidth, textAlign)
	    
	out = cStringIO.StringIO()
	im.save(out, imFormat)
	out.seek(0)
	data = out.read()
	out.close()

	self.manage_upload(data)  
	self.content_type = "image/" + string.lower(imFormat)
    	